/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookAdsControllerActionAdSetRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookAdsControllerActionAdSetRequest{}

// FacebookAdsControllerActionAdSetRequest struct for FacebookAdsControllerActionAdSetRequest
type FacebookAdsControllerActionAdSetRequest struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	AccountId  *string `json:"accountId,omitempty"`
	CampaignId *string `json:"campaignId,omitempty"`
}

// NewFacebookAdsControllerActionAdSetRequest instantiates a new FacebookAdsControllerActionAdSetRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookAdsControllerActionAdSetRequest() *FacebookAdsControllerActionAdSetRequest {
	this := FacebookAdsControllerActionAdSetRequest{}
	return &this
}

// NewFacebookAdsControllerActionAdSetRequestWithDefaults instantiates a new FacebookAdsControllerActionAdSetRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookAdsControllerActionAdSetRequestWithDefaults() *FacebookAdsControllerActionAdSetRequest {
	this := FacebookAdsControllerActionAdSetRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *FacebookAdsControllerActionAdSetRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsControllerActionAdSetRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *FacebookAdsControllerActionAdSetRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *FacebookAdsControllerActionAdSetRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *FacebookAdsControllerActionAdSetRequest) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsControllerActionAdSetRequest) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *FacebookAdsControllerActionAdSetRequest) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *FacebookAdsControllerActionAdSetRequest) SetAccountId(v string) {
	o.AccountId = &v
}

// GetCampaignId returns the CampaignId field value if set, zero value otherwise.
func (o *FacebookAdsControllerActionAdSetRequest) GetCampaignId() string {
	if o == nil || IsNil(o.CampaignId) {
		var ret string
		return ret
	}
	return *o.CampaignId
}

// GetCampaignIdOk returns a tuple with the CampaignId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsControllerActionAdSetRequest) GetCampaignIdOk() (*string, bool) {
	if o == nil || IsNil(o.CampaignId) {
		return nil, false
	}
	return o.CampaignId, true
}

// HasCampaignId returns a boolean if a field has been set.
func (o *FacebookAdsControllerActionAdSetRequest) HasCampaignId() bool {
	if o != nil && !IsNil(o.CampaignId) {
		return true
	}

	return false
}

// SetCampaignId gets a reference to the given string and assigns it to the CampaignId field.
func (o *FacebookAdsControllerActionAdSetRequest) SetCampaignId(v string) {
	o.CampaignId = &v
}

func (o FacebookAdsControllerActionAdSetRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookAdsControllerActionAdSetRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.CampaignId) {
		toSerialize["campaignId"] = o.CampaignId
	}
	return toSerialize, nil
}

type NullableFacebookAdsControllerActionAdSetRequest struct {
	value *FacebookAdsControllerActionAdSetRequest
	isSet bool
}

func (v NullableFacebookAdsControllerActionAdSetRequest) Get() *FacebookAdsControllerActionAdSetRequest {
	return v.value
}

func (v *NullableFacebookAdsControllerActionAdSetRequest) Set(val *FacebookAdsControllerActionAdSetRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookAdsControllerActionAdSetRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookAdsControllerActionAdSetRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookAdsControllerActionAdSetRequest(val *FacebookAdsControllerActionAdSetRequest) *NullableFacebookAdsControllerActionAdSetRequest {
	return &NullableFacebookAdsControllerActionAdSetRequest{value: val, isSet: true}
}

func (v NullableFacebookAdsControllerActionAdSetRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookAdsControllerActionAdSetRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
